; Terminal znakowy, obsuga interfejsw szeregowych
; Rafa Baranowski (C) 2004

.INCLUDE "m16def.inc"		; SEGMENT DEKLARACJI
					; stae interfejsu PS/2
.EQU PS2_ROZM_BO	= 30		;   rozmiar bufora odbiorczego
.EQU K_PS2		= DDRD	;   rejestr kierunku portu
.EQU O_PS2		= PORTD	;   rejestr wyjciowy portu
.EQU I_PS2		= PIND	;   rejestr wejciowy portu
.EQU PS2_CLK	= 3		;   nr linii dla sygnau CLK
.EQU PS2_DTA	= 2		;   nr linii dla sygnau DTA (INT0)
					; stae interfejsu RS-232
.EQU OSC_FREQ	= 16000000	;   czstotliwo rezonatora kwarcowego [Hz]
.EQU RS_BAUD	= 9600	;   prdko transmisji [bps]
.EQU RS_ROZM_BN	= 10		;   rozmiar bufora nadawczego
.EQU RS_ROZM_BO	= 10		;   rozmiar bufora odbiorczego
					; stae wywietlacza LCD
.EQU K_LCD		= DDRA	;   rejestr kierunku portu
.EQU O_LCD		= PORTA	;   rejestr wyjciowy portu
.EQU LCD_RS		= 0		;   nr linii dla sygnau RS
.EQU LCD_EN		= 1		;   nr linii dla sygnau EN
.EQU LCD_DB4	= 2		;   nr linii dla sygnau DB4
.EQU LCD_DB5	= 3		;   nr linii dla sygnau DB5
.EQU LCD_DB6	= 4		;   nr linii dla sygnau DB6
.EQU LCD_DB7	= 5		;   nr linii dla sygnau DB7
					; inne stae
.EQU SYS_FREQ	= OSC_FREQ/1000000; czstotliwo pracy w MHz (dla opnie)


.DSEG					; SEGMENT DANYCH
.ORG 0x0060				; pocztek pamici SRAM
						; zmienne interfejsu PS/2
PS2_BUF_O:		.BYTE	PS2_ROZM_BO	;   bufor odbiorczy interfejsu PS/2
PS2_WSK_RBO:	.BYTE 1		;   wskanik odczytu bufora odbiorczego
PS2_WSK_WBO:	.BYTE 1		;   wskanik zapisu bufora odbiorczego
						; zmienne klawiatury PC
PS2_ZNACZ:		.BYTE 1		;   zmienna znacznikw stanu klawiatury
						; zmienne interfejsu RS-232
RS_BUF_N:		.BYTE	RS_ROZM_BN	;   bufor nadawczy
RS_WSK_RBN:		.BYTE 1		;   wskanik odczytu bufora nadawczego
RS_WSK_WBN:		.BYTE 1		;   wskanik zapisu bufora nadawczego
RS_BUF_O:		.BYTE	RS_ROZM_BO	;   bufor odbiorczy
RS_WSK_RBO:		.BYTE 1		;   wskanik odczytu bufora odbiorczego
RS_WSK_WBO:		.BYTE 1		;   wskanik zapisu bufora odbiorczego


.CSEG					; SEGMENT PROGRAMU
.ORG	0				; wektor zerowania
	jmp	Reset			; skok do procedury inicjalizujcej
.ORG	INT0addr			; wektor przerwania INT0
	jmp	Odbior_PS2		; skok do obsugi bufora odbiorczego interfejsu PS/2
.ORG	URXCaddr			; wektor przerwania RXC
	jmp	Odbior_RS		; skok do obsugi bufora odbiorczego interfejsu RS-232
.ORG	UDREaddr			; wektor przerwania UDRE
	jmp	Nadawanie_RS	; skok do obsugi bufora nadawczego interfejsu RS-232

.ORG	0x30				; przejcie do pierwszej komrki za wektorami przerwa

					; deklaracje staych w pamici programu
Powitanie:	.db	"Terminal znakowy", ZNAK_KONCA	; Tekst powitalny


Reset:				; podprogram inicjalizujcy
	ldi	R17, high(RAMEND)
	ldi	R16, low(RAMEND)
	out	SPH, R17
	out	SPL, R16		; inicjalizacja wskanika stosu

	rcall	Ini_PS2		; inicjalizacja interfejsu PS/2
	rcall	Ini_klaw_PS2	; inicjalizacja klawiatury PC
	rcall	Ini_RS		; inicjalizacja interfejsu RS-232
	rcall	Ini_LCD		; inicjalizacja wywietlacza LCD

	ldi	ZH, high(Powitanie<<1)
	ldi	ZL, low(Powitanie<<1)
	rcall	Pokaz_ciag_LCD	; wywietlenie powitania ("Terminal znakowy")

	ldi	R17, 100
	ldi	R16, 10
	rcall	Czekaj_ms		; opnienie o 1 s

	rcall	Czysc_LCD		; czyszczenie wywietlacza

	ldi	R16, (1<<LCD_TRYB)|(1<<LCD_T_INC)|(1<<LCD_T_PRZES)
	rcall	Instrukcja_LCD	; LCD pracuje w trybie przesuwania przy wprowadzaniu
	ldi	R16, 15|(1<<LCD_DDADR)
	rcall	Instrukcja_LCD	; kursor LCD ustawiony na koniec pierwszej linii

	sei				; odblokowanie przerwa


Petla:				; ptla gwna programu
;	ldi	R16, 100
;	ldi	R17, 10
;	rcall	Czekaj_ms		; opnienie o 1 s (do testowania buforw)

	rcall Pobierz_ASCII_PS2 ; sprawd, czy mona odczyta kod ASCII z bufora
					;   odbiorczego interfejsu PS/2
	brtc	Petla_1		; jeli tak (T=1), to..
	mov	R17, R16
	rcall	Wyslij_kod_RS	;   wylij odebrany znak poprzez interfejs RS-232
	mov	R16, R17
	rcall	Zapisz_LCD		;   i wywietl go na LCD

Petla_1:
	rcall	Pobierz_kod_RS	; sprawd, czy mona odczyta warto z bufora
					;   odbiorczego interfejsu RS-232
	brtc	Petla			; jeli tak (T=1), to..
	rcall	Zapisz_LCD		;   wywietl odebrany znak na LCD

	rjmp	Petla			; zaptl program


					; DOCZANE PODPROGRAMY
.INCLUDE "czekaj_ms.inc"	;   oczekiwanie milisekundowe
.INCLUDE "czekaj_us.inc"	;   oczekiwanie mikrosekundowe
.INCLUDE "ps2_buf.inc"		;   buforowana obsuga interfejsu PS/2
.INCLUDE "uart_buf.inc"		;   buforowana obsuga interfejsu RS-232
.INCLUDE "klaw_ps2.inc"		;   obsuga klawiatury PC
.INCLUDE "lcd.inc"		;   obsuga wywietlacza LCD
